/**
 *	@file	fname.c
 *	@brief	t@C̏.
 *	@author tenk*
 *	@note
 *	-	c/c++ p.
 *	-	win / linux(unix) p.
 *		winł\ /AȊO/Zp[^.
 *		ꉞdos肵Ă邪Aint=2bytelĂȂ̂Œ.
 *	-	0x80asciinł邱ƑO.
 *	-	SJIS̃}`oCgΉ.
 *		- Winł̓}`oCgCharNextŃ|C^i߂Ă.
 *		  (CharNextUTF8ΉĂ悤.łwin̂MBCDBĈ
 *		  utf8ΉĂȂ)
 *		- WinȊO̊ł́AϐLANG݂, SJIS,BIG5,GBKl.
 *		  (炭Sp2oCgڂ0x5ĉ́Aꂭ炢?Ƒz)
 *		- r֌ẂAP[Ήs\ɂ딻肠肦?
 *	-	path̍ő咷lāAsize_t łȂ unsigned ŃTCYw.
 *	-	Public Domain Software
 */

#include "fname.h"
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#ifdef FNAME_USE_MBC_H
#include "mbc.h"
#endif

// fullpath allocagȂꍇ`.
//#define UNUSE_ALLOCA

#if defined _DOS || defined _MSDOS
#define MSDOS
#endif


// os ̈Ⴂ֌W.
#if defined _WIN32
 #include <windows.h>
 #include <malloc.h>
 #if defined _MSC_VER
  #pragma comment(lib, "User32.lib")			// CharNext()ŕKv...
  #pragma warning(disable: 4244)
 #endif
#else	// linux
 #include <string.h>
 #include <alloca.h>
 #include <dirent.h>
 #include <sys/stat.h>
#endif


// unicodeΉ.  mbngꂽȂ tchar.h g킸OőΏ.
#ifdef UNICODE	// wchar_t Ή.
 #ifndef _T
  #define _T(x)					L##x
 #endif
 #define TCHAR					wchar_t
 #define FNAME_LEN(s)			wcslen(s)
 #define FNAME_R_STR(s,c)		wcsrchr((s),(c))
 #if defined _WIN32 || defined MSDOS	// 召ꎋ.
  #define FNAME_CMP(l,r)		_wcsicmp((l),(r))
 #else									// 召.
  #define FNAME_CMP(l,r)		wcscmp((l),(r))
 #endif
#else			// char x[X.
 #ifndef _T
  #define _T(x)					x
 #endif
 #define TCHAR					char
 #define FNAME_LEN(s)			strlen(s)
 #define FNAME_R_STR(s,c)		strrchr((s),(c))
 #if defined _WIN32 || defined MSDOS	// 召ꎋ.
  #define FNAME_CMP(l,r)		_stricmp((l),(r))
  #define FNAME_N_CMP(l,r,n)	_strnicmp((l),(r),(n))
 #else									// 召.
  #define FNAME_CMP(l,r)		strcmp((l),(r))
  #define FNAME_N_CMP(l,r,n)	strncmp((l),(r),(n))
 #endif
#endif

#ifdef FNAME_SEP_CHR
#define DIRSEP_CHR				FNAME_SEP_CHR
#elif defined MSDOS
#define DIRSEP_CHR				_T('\\')
#else	// WinNTn(2K?ȍ~)ȂAfBNgZp[^Ƃ / ŖȂ../Ή\tĝ\.
#define DIRSEP_CHR				_T('\\')
#endif

#if defined _WIN32 || defined MSDOS
#define IS_DIRSEP(c)			((c) == _T('\\') || (c) == _T('/'))
#else
#define IS_DIRSEP(c)			((c) == _T('/'))
#endif


// c/c++ ΍.
#ifdef __cplusplus				// c++̏ꍇA|C^݂̂̊֐const,constł.
 #define FNAME_const			/*const*/		// ̂߁A{́Aconst֐ɂ.
#else							// c̏ꍇ͕WCuɂ킹 constŖ߂l const ɂ.
 #define FNAME_const			const
 #if defined _WIN32 || defined MSDOS
  #define inline				__inline	// winnCłinlineȂĂ__inline͂܂.
 #endif
#endif



// ============================================================================
// }`oCg0x5c ΍֌W.

#ifdef FNAME_USE_MBC_H	// mbc.h gꍇ.

#include "mbc.h"
#define FNAME_ISMBBLEAD(c)		mbcd_is_lead(c)
#define FNAME_CHARNEXT(p)		mbcd_inc(p)

void fname_init(void) {}
void fname_term(void) {}


#else	// mbc.h gȂꍇ.

///  C  MSSp̂PoCgڂۂ. (utf8euc \ ͖̂ 0Aok)
#if defined _WIN32
 #define FNAME_ISMBBLEAD(c)		IsDBCSLeadByte(c)
#elif defined UNICODE
 //#define FNAME_ISMBBLEAD(c)	(0)
#elif defined HAVE_MBCTYPE_H
 #define FNAME_ISMBBLEAD(c)		_ismbblead(c)
#else
 #define FNAME_ISMBBLEAD(c)		((unsigned)(c) >= 0x80 && fname_is_zenkaku1((c)))
#endif

/// ̕փ|C^i߂. CharNext()TQ[gyAutf8ΉĂĂ炢ȂƊ(ʖڂ)
#if  defined _WIN32
#define FNAME_CHARNEXT(p)		(TCHAR*)CharNext((TCHAR*)(p))
#elif defined UNICODE
#define FNAME_CHARNEXT(p)		((p) + 1)
#else
#define FNAME_CHARNEXT(p)		((p) + 1 + (FNAME_ISMBBLEAD(*(unsigned char*)(p)) && (p)[1]))
#endif


// ----------------------------------
// win ȊOŁAsjisΉꍇ̏.

#if !defined(_WIN32) && !defined(HAVE_MBCTYPE_H)	// win32ȊO, LANGΉꍇ.

static unsigned    s_fname_shift_char_mode = 0;
//static const char* s_fname_locale_ctype  = 0;

#ifdef __cplusplus	// c++ Ȃ玩 fname_init()Ăяo.
struct fname_INIT {
	fname_INIT()  { fname_init(); }
	~fname_INIT() { fname_term(); }
};
static fname_INIT	s_fname_init;
#endif	// __cplusplus


/** Ƃ肠A0x5c֌W̑Ώp.
 */
void fname_init(void)
{
	const char* 		lang = getenv(_T("LANG"));
	const char* 		p;
	s_fname_shift_char_mode	 = 0;
	if (lang == 0)
		return;
	//s_fname_locale_ctype = strdup(lang);
	// ja_JP.SJIS ̂悤Ȍ`ł邱ƂOSJIS,big5,gbk`FbN.
	p = strrchr(lang, '.');
	if (p) {
		const char* enc = p + 1;
		// 0x5c΍􂪕Kvencoding`FbN.
		if (strncasecmp(enc, "sjis", 4) == 0) {
			s_fname_shift_char_mode	= 1;
		} else if (strncasecmp(enc, "gbk", 3) == 0 || strncasecmp(enc, "gb2312", 6) == 0) {
			s_fname_shift_char_mode	= 2;
		} else if (strncasecmp(enc, "big5", 4) == 0) {
			s_fname_shift_char_mode	= 3;
		}
	}
}


void fname_term(void)
{
	//free((char*)s_fname_locale_ctype);
	//s_fname_locale_ctype = 0;
}


#ifndef UNICODE
static int fname_is_zenkaku1(unsigned c) {
	switch (s_fname_shift_char_mode) {
	case 1 /* sjis */: return ((c >= 0x81 && c <= 0x9F) || (c >= 0xE0 && c <= 0xFC));
	case 2 /* GBK  */: return (c >= 0x81 && c <= 0xFE);
	case 3 /* BIG5 */: return ((c >= 0xA1 && c <= 0xC6) || (c >= 0xC9 && c <= 0xF9));
	default:		   return 0;
	}
}
#endif	// UNICODE

#endif	// !defined(_WIN32) && !defined(HAVE_MBCTYPE_H)


#endif	// FNAME_USE_MBC_H



// ============================================================================

#define TO_UPPER(c)		(((c) >= _T('a') && (c) <= _T('z')) ? (c) - _T('a') + _T('A') : (c))
#define TO_LOWER(c)		(((c) >= _T('A') && (c) <= _T('Z')) ? (c) - _T('A') + _T('a') : (c))


/** ΃pXۂ(hCu̗L͊֌WȂ)
 */
int	fname_isAbs(const TCHAR* path)
{
	if (path == 0)
		return 0;
	path = fname_skipDrive(path);
	return IS_DIRSEP(path[0]);
}



/** hCuĂ邩.
 */
int		fname_haveDrive(const TCHAR* path)
{
  #if 1	// 擪":"hCuƂ݂Ȃ.
	const TCHAR* s = path;
	if (s == 0)
		return 0;
	if (*s && *s != _T(':')) {
		while (*s && !IS_DIRSEP(*s)) {
			if (*s == _T(':')) {
				return 1;
			}
			++s;
		}
	}
	return 0;
  #else	// ꎚhCûݑΉꍇ.
   #if defined _WIN32 || defined MSDOS
	if (path == 0)
		return 0;
	return (path[0] && path[1] == _T(':'));
   #else
	return 0;
   #endif
  #endif
}



// ============================================================================

/** sizeɎ܂镶̕Ԃ. \0܂܂Ȃ.
 *	(winł͂Ȃׂ}`oCg̓rŏIȂ悤ɂ.
 *	 ǁAprIɂ͐؂ȏ゠܂ӖȂ...)
 */
unsigned	fname_adjust_size(const TCHAR* str, unsigned size)
{
	const TCHAR* s = str;
	const TCHAR* b = s;
	const TCHAR* e = s + size;
	assert(str != 0 && size > 0);
	while (s < e) {
		if (*s == 0)
			return s - str;
		b = s;
		s = FNAME_CHARNEXT(s);
	}
	return b - str;
}



/** t@C̃Rs[. mbc͕̎Ȃ܂. dst == src ok.
 */
TCHAR*	fname_cpy(TCHAR dst[], unsigned dstSz, const TCHAR* src)
{
	unsigned 	l;
	assert(dst != NULL && dstSz > 0);

	if (src == NULL)
		return NULL;
	l = fname_adjust_size(src, dstSz);

	// AhXȂA킹̂.
	if (dst == src) {
		dst[l] = 0;
		return dst;
	}

	// Rs[.
	{
		const TCHAR*	s = src;
		const TCHAR*	e = s + l;
		TCHAR*			d = dst;
		while (s < e)
			*d++ = *s++;
		*d = 0;
	}

	return dst;
}



/** t@C̘A.
 */
TCHAR*	fname_cat(TCHAR dst[], unsigned dstSz, const TCHAR* src)
{
	unsigned l;
	assert(dst != NULL && dstSz > 0);
	if (src == 0)
		return NULL;
	assert(src != 0 && dst != src);
	l = FNAME_LEN(dst);
	if (l >= dstSz) {	// ]悪tȂTCŶ.
		return fname_cpy(dst, dstSz, dst);
	}
	fname_cpy(dst+l, dstSz - l, src);
	return dst;
}



// ============================================================================

/** hCu΂XLbv|C^Ԃ.
 *	  c:łȂhttp:XLbv邽 ":" XLbv.
 */
TCHAR *fname_skipDrive(FNAME_const TCHAR* path)
{
  #if 1
	const TCHAR* s = path;
	if (*s && *s != _T(':')) {
		while (*s && !IS_DIRSEP(*s)) {
			if (*s == _T(':')) {
				return (TCHAR*)s+1;
			}
			++s;
		}
	}
 #else	// 1hCû݂̑ΉȂ炱.
  #if defined _WIN32 || defined MSDOS
	if (path[0] && path[1] == _T(':'))		// hCut
		return (TCHAR*) path + 2;
	#endif
 #endif
	return (TCHAR*)path;
}



/** 擪̃hCu,[gwXLbv|C^Ԃ.
 */
TCHAR *fname_skipDriveRoot(FNAME_const TCHAR* path)
{
	TCHAR* p = fname_skipDrive(path);
	while (IS_DIRSEP(*p))
		++p;
	return p;
}



/** t@CpX̃fBNgt@C̈ʒuԂ.
 */
TCHAR *fname_baseName(FNAME_const TCHAR *adr)
{
	const TCHAR *p = adr;
	assert(adr != 0);
	while (*p) {
		if (*p == _T(':') || IS_DIRSEP(*p))
			adr = (TCHAR*)p + 1;
		p = FNAME_CHARNEXT(p);
	}
	return (TCHAR*)adr;
}



/**	gq̈ʒuԂ. '.'͊܂܂Ȃ. ȂΕ̍ŌԂ.
 */
TCHAR *fname_ext(FNAME_const TCHAR *name)
{
	const TCHAR *p;
	assert(name != 0);
	name = fname_baseName(name);
	p = FNAME_R_STR(name, _T('.'));
	if (p) {
		return (TCHAR*)(p+1);
	}
	return (TCHAR*)name + FNAME_LEN(name);
}



// ============================================================================

/** t@CpX̊gq폜.
 */
TCHAR *fname_delExt(TCHAR buf[])
{
	TCHAR *t;
	TCHAR *p;
	assert(buf != 0);
	t = fname_baseName(buf);
	p = FNAME_R_STR(t, _T('.'));
	if (p == 0) {
		p = t + FNAME_LEN(t);
	}
	*p = 0;
	return buf;
}



/** t@CpX̊gq̎擾.
 */
TCHAR *fname_getNoExt(TCHAR dst[], unsigned size, const TCHAR *src)
{
	const TCHAR *s;
	const TCHAR *e;
	unsigned		 l = 0;
	assert(dst != 0 && size > 1 && src != 0);
	//if (dst == 0 || size == 0 || src == 0) return 0;
	s = fname_baseName(src);
	e = FNAME_R_STR(s, _T('.'));
	if (e == 0) {
		e = s + FNAME_LEN(s);
	}
	l = e - src + 1;
	if (l > size)
		l = size;
	fname_cpy(dst, l, src);
	return dst;
}



/** t@CpX̃fBNgƊgqt@C̎擾.
 */
TCHAR *fname_getBaseNameNoExt(TCHAR dst[], unsigned size, const TCHAR *src)
{
	const TCHAR *s;
	const TCHAR *e;
	unsigned		 l = 0;
	assert(dst != 0 && size > 1 && src != 0);
	//if (dst == 0 || size == 0 || src == 0) return 0;
	s = fname_baseName(src);
	e = FNAME_R_STR(s, _T('.'));
	if (e == 0) {
		e = s + FNAME_LEN(s);
	}
	l = e - s + 1;
	if (l > size)
		l = size;
	fname_cpy(dst, l, s);
	return dst;
}



/**	gqAext ɕύX. dst == src ł悢.
 *	ext = NULL or "" ̂Ƃ gq폜.
 */
TCHAR *fname_setExt(TCHAR dst[], unsigned size, const TCHAR* src, const TCHAR *ext)
{
	assert(dst != 0 && size > 0 && src != 0);
	fname_getNoExt(dst, size, src);
	if (ext && ext[0]) {
		fname_cat(dst, size, _T("."));
		fname_cat(dst, size, ext);
	}
	return dst;
}



/**	gqȂꍇAgqǉ.(ΉȂ). dst == src ł悢.
 */
TCHAR *fname_setDefaultExt(TCHAR dst[], unsigned size, const TCHAR* src, const TCHAR *ext)
{
	TCHAR*	p;
	assert(dst != 0 && size > 0 && src != 0);

	fname_cpy(dst, size, src);
	if (ext == 0)
		return dst;
	p = fname_baseName(dst);
	p = FNAME_R_STR(p, _T('.'));
	if (p) {
		if (p[1])
			return dst;
		*p = 0;
	}
	if (ext[0]) {
		fname_cat(dst, size, _T("."));
		fname_cat(dst, size, ext);
	}
	return dst;
}



// ============================================================================

/**	hCu擾. :.  file:̑Ώ̂":"hCu
 */
TCHAR *fname_getDrive(TCHAR drive[], unsigned size, const TCHAR *name)
{
	const TCHAR*	s;
	unsigned	 	l;
	assert(drive && size > 0 && name);
	drive[0] = 0;
	s = fname_skipDrive(name);
	l = s - name;
	if (l > 0) {
		++l;
		if (l > size)
			l = size;
		fname_cpy(drive, l, name);
	}
	return drive;
}



/**	hCuƃ[gw蕔擾.
 */
TCHAR *fname_getDriveRoot(TCHAR dr[], unsigned size, const TCHAR *name)
{
	const TCHAR* s;
	unsigned	 	  l;
	assert(dr && size > 0 && name);
	dr[0] = 0;
	s = fname_skipDriveRoot(name);
	l = s - name;
	if (l > 0) {
		++l;
		if (l > size)
			l = size;
		fname_cpy(dr, l, name);
	}
	return dr;
}



/**	fBNgԂ. Ō̃fBNgZp[^͊O.
 */
TCHAR *fname_getDir(TCHAR dir[], unsigned size, const TCHAR *name)
{
  #if 1
	const TCHAR *p;
	size_t		 l;

	assert(dir	!= 0 && size > 0 && name != 0);

	p = fname_baseName(name);
	l = p - name + 1;
	if (l > size) {
		l = size;
	}
	if (l && dir != name)
		fname_cpy(dir, l, name);
	dir[l] = 0;
	if (l > 0)
		fname_delLastSep(dir);
	return dir;
  #else
	const TCHAR *p	 = name;
	const TCHAR *de  = dir + size - 1;
	const TCHAR *adr = 0;
	assert(dir && size > 1 && path);
	while (*p && d < de) {
		if (*p == _T(':') || *p == _T('/')
		  #ifdef _WIN32
		  	|| *p == _T('\\')
		  #endif
		) {
			adr = d;
		}
	  #ifdef _WIN32
		if (IsDBCSLeadByte(*p) && p[1] && d+1 < de)
			*d++ = *p++;
	  #endif
		*d++ = *p++;
	}
	if (adr) {
		*adr = 0;
	}
	*d = 0;
	return dir;
  #endif
}



#if 0
/** name ̃hCuƃx[X𔲂fBNgdir[]ɓĕԂ.
 */
TCHAR *fname_getMidDir(TCHAR dir[], unsigned size, const TCHAR *name) {
	return fname_getDir(dir, size, fname_skipDriveRoot(name));
}
#endif



// ============================================================================

/** ̍Ō \  / ΂̈ʒuԂAȂNULLԂ.
 */
TCHAR *fname_checkLastSep(FNAME_const TCHAR* dir)
{
	assert(dir != 0);
	if (dir) {
		const TCHAR*	s 	= dir;
		unsigned		l	= FNAME_LEN(s);
		if (l > 0) {
			unsigned	 ofs = l - 1;
			const TCHAR* p	 = s + ofs;
			if (*p == _T('/')) {
				return (TCHAR *)p;
			}
		  #if (defined _WIN32 || defined MSDOS)
			else if (*p == _T('\\')) {
			  #ifdef UNICODE
				return (TCHAR *)p;
			  #else		// adjust_sizěʂofsɂȂĂ*p̓}`oCg̈ꕔ.
				if (fname_adjust_size(s, ofs+1) == ofs)
					return (TCHAR *)p;
			  #endif
			}
		  #endif
		}
	}
	return NULL;
}



/** ̍Ō \  / ΍폜
 */
TCHAR *fname_delLastSep(TCHAR dir[])
{
	TCHAR*	p = fname_checkLastSep(dir);
	if (p) {
		*p = 0;
	}
	return dir;
}



/** ̍Ō fBNgZp[^ȂΒǉ.
 */
TCHAR *fname_addSep(TCHAR dir[], unsigned size)
{
	TCHAR*	e = dir + size;
	TCHAR*	p = fname_checkLastSep(dir);
	if (p == 0) {
		p = dir + FNAME_LEN(dir);
		if (p+1 < e) {
			*p++ = DIRSEP_CHR;
			*p = 0;
		}
	}
	return dir;
}



/** fBNgƃt@C. fname_cat ƈႢA\ / Ԃɕt.
 */
TCHAR *fname_join(TCHAR buf[], unsigned bufSz, const TCHAR *dir, const TCHAR *name)
{
	fname_cpy(buf, bufSz, dir);
	if (buf[0])
		fname_addSep(buf, bufSz);
	fname_cat(buf, bufSz, name);
	return buf;
}


// ============================================================================

/** SpQoCgڂl strupr
 */
TCHAR *fname_toUpper(TCHAR name[])
{
	TCHAR *p = name;
	assert(name != NULL);
	while (*p) {
		unsigned c = *p;
		*p = TO_UPPER(c);
		p  = FNAME_CHARNEXT(p);
	}
	return name;
}



/** SpQoCgڂl strlwr
 */
TCHAR *fname_toLower(TCHAR name[])
{
	TCHAR *p = name;
	assert(name != NULL);

	while (*p) {
		unsigned c = *p;
		*p = TO_LOWER(c);
		p  = FNAME_CHARNEXT(p);
	}
	return name;
}



/** filePath \  / ɒu.
 */
TCHAR 	*fname_backslashToSlash(TCHAR filePath[])
{
	TCHAR *p = filePath;
	assert(filePath != NULL);
	while (*p != _T('\0')) {
		if (*p == _T('\\')) {
			*p = _T('/');
		}
		p = FNAME_CHARNEXT(p);
	}
	return filePath;
}



/** filePath /  \ ɒu.
 */
TCHAR 	*fname_slashToBackslash(TCHAR filePath[])
{
	TCHAR *p;
	assert(filePath != NULL);
	for (p = filePath; *p; ++p) {
		if (*p == _T('/')) {
			*p = _T('\\');
		}
	}
	return filePath;
}



// ============================================================================

TCHAR*	fname_fullpath(TCHAR dst[], unsigned size, const TCHAR* path, const TCHAR* currentDir) {
  #if defined WIN32 || defined MSDOS
	return fname_fullpathBS(dst, size, path, currentDir);
  #else
	return fname_fullpathSL(dst, size, path, currentDir);
  #endif
}


/** tpX. fBNgZp[^\\ɂĕԂo[W.
 */
TCHAR*	fname_fullpathBS(TCHAR dst[], unsigned size, const TCHAR* path, const TCHAR* currentDir)
{
	fname_fullpathSL(dst, size, path, currentDir);
	fname_slashToBackslash(dst);
	return dst;
}


/** tpX. 񑀍̂. JgpX͈œn.
 *	currentDir ͐΃pXł邱. łȂꍇ͕̋s.
 *	'\'΍ŁAZp[^'/'ɒuĂ.
 */
TCHAR*	fname_fullpathSL(TCHAR dst[], unsigned size, const TCHAR* path, const TCHAR* currentDir)
{
	TCHAR*		wk;
	unsigned 	wkSz;

	assert(dst != 0 && size > 2 && path != 0);
	if (dst == 0 || size <= 2 || path == 0)
		return 0;
	if (currentDir == 0)
		currentDir = _T("/");	// DIRSEP_STR;
	assert(fname_isAbs(currentDir));

  #if !(defined UNUSE_ALLOCA)
	// ݐTCY\łȂ΍Ɨpm.
	{
		unsigned pl = FNAME_LEN(path);
		unsigned cl = FNAME_LEN(currentDir);
		wkSz = pl + cl + 4;
		if (wkSz >= size) {		// dstTCYAȂ烏[Np.
			wk = (TCHAR*)alloca(wkSz);
			if (wk == 0) {
				wk	 = dst;
				wkSz = size;
			}
		} else {
			wkSz = size;
			wk	 = dst;
		}
	}
  #else	// allocaSgȂꍇ͏o͐𒼐ڎg.
	wkSz = size;
	wk	 = dst;
  #endif

	// Ɨp̐΃pX.
	{
		unsigned haveDrive = fname_haveDrive(path);
		unsigned isAbs	   = fname_isAbs(path);
		wk[0] = 0;
		if (isAbs && haveDrive) {	// hCut΃pXȂÂ܂.
			fname_cpy(wk, wkSz, path);
		} else if (isAbs) {
			if (fname_haveDrive(currentDir)) {	// ΃pXǃhCuȂꍇcurrentDirhCu.
				fname_getDrive(wk, wkSz, currentDir);
			}
			fname_cat(wk, wkSz, path);
		} else {
			if (haveDrive) {					// hCut΃pXŁA
				if (!fname_haveDrive(currentDir))	// JgɃhCuȂ
					fname_getDrive(wk, wkSz, path);	// path̃hCuݒ. ΃Jg̃hCuɂȂ.
			}
			fname_cat(wk, wkSz, currentDir);
			fname_addSep(wk, wkSz);
			fname_cat(wk, wkSz, fname_skipDrive(path));
		}
	}

  #if defined _WIN32 || defined MSDOS
	// ȒPɂ邽߁ApX̋؂U / ɕϊ.
	fname_backslashToSlash(wk);
  #endif

	// "."  ".." 菜.
	{
		// ̎_wk͕K΃pXɂȂĂ.(currentDirᔽĂꍇ͕̋s舵).
		TCHAR*		s	  = fname_skipDrive(wk);	// hCu͘MȂ̂ŃXLbv.
		TCHAR*		d	  = s;
		TCHAR*		top   = d;
		unsigned	first = 1;
		while (*s) {
			unsigned c = *s++;
			if (c == _T('/')) {
				if (first) {	//  /  "//" "///" ... Ƃ*d++=ĉłł2܂.
					unsigned i;
					for (i = 0; i < 2 && *s == _T('/'); ++i) {
						*d++ = *s++;
					}
				}
				first = 0;
				// '/'̘A͈'/'.
			  RETRY:
				while (*s == _T('/'))
					++s;
				if (*s == _T('.')) {
					if (s[1] == 0) {					// "." ݂͖̂.
						s += 1;
						goto RETRY;
					} else if (s[1] == _T('/')) {		// "./" ͖.
						s += 2;
						goto RETRY;
					} else if (s[1] == _T('.') && (s[2] == _T('/') || s[2] == 0)) {	// "../" ".." ̂Ƃ.
						s += 2 + (s[2] != 0);
						while (d > top && *--d != _T('/')) {	// o͐̃fBNgKwP炷.
							;
						}
						goto RETRY;
					}
				}
			}
			*d++ = c;
		}
		*d = 0;
	}

  #if !(defined UNUSE_ALLOCA)
	if (wk != dst) {	// [NallocaĂ̂ȂARs[.
		fname_cpy(dst, size, wk);
	}
  #endif

	return dst;
}




// ============================================================================
#if 1	// {͕ʃW[.
/** R}hCA;؂̕pXwÂɎg.
 *	""winR}hCɂ킹.
 *	sepChrŋ؂ꂽ(t@C)擾. 0x20ȊŐ󔒂͖0x20.
 *	@return XLXṼAhXԂBstrEOSNULLԂ.
 */
TCHAR *fname_scanArgStr(TCHAR arg[], unsigned argSz, const TCHAR *str, unsigned sepChr)
{
  #ifdef UNICODE
	const TCHAR*		 s = str;
  #else
	const unsigned char* s = (const unsigned char*)str;
  #endif
	TCHAR*	  			 d = arg;
	TCHAR*				 e = d + argSz;
	unsigned 			 f = 0;
	unsigned			 c;

	assert( str != 0 && arg != 0 && argSz > 1 );

	// 0x20ȊŐ󔒂ƃZp[^XLbv.
	while ( *s == sepChr || (*s > 0 && *s < 0x20) || *s == 0x7f) {
		++s;
	}
	if (*s == 0) {	// EOSAȂƂNULLԂ.
		arg[0] = 0;
		return NULL;
	}

	do {
		c = *s++;
		if (c == _T('"')) {
			f ^= 1;							// "̑΂̊Ԃ͋󔒂t@Cɋ.߂̃tO.

			// ƋCAWin(XP)cmd.exe̋ɍ킹Ă݂.
			// (قƂɂĂ邩A\ɂׂ͒ĂȂ)
			if (*s == _T('"') && f == 0)	// "̒ɂ"΁A͂̂܂ܕ\.
				++s;
			else
				continue;					// ʏ " ͏ȂĂ܂.
		}
		if ((c > 0 && c < 0x20) || c == 0x7f)
			c = _T(' ');
		if (d < e) {
			*d++ = (TCHAR)c;
		}
	} while (c >= 0x20 && c != 0x7f && (f || (c != sepChr)));
	*--d  = _T('\0');
	--s;
	return (TCHAR *)s;
}
#endif



// ============================================================================

// t@C̃|C^p1擾cɂ}N.
// oswinȂ2oCgΉŏ. utf8͔j].
#ifdef UNICODE
 #if defined _WIN32 || defined MSDOS
  #define FNAME_GET_C(c, p)		((c) = *((p)++), (c) = TO_LOWER(c))
 #else
  #define FNAME_GET_C(c, p)		((c) = *((p)++))
 #endif
#else
 #if defined _WIN32 || defined MSDOS
  #define FNAME_GET_C(c, p)	do {							\
		(c) = *(unsigned char*)((p)++);						\
		if (FNAME_ISMBBLEAD(c) && *(p))						\
			(c) = ((c) << 8) | *(unsigned char*)((p)++);	\
		else												\
			(c) = TO_LOWER(c);								\
	} while (0)
 #else
  #define FNAME_GET_C(c, p)	do {							\
		(c) = *(unsigned char*)((p)++);						\
		if (FNAME_ISMBBLEAD(c) && *(p))						\
			(c) = ((c) << 8) | *(unsigned char*)((p)++);	\
	} while (0)
 #endif
#endif



/** t@C̑召r.
 *	win/dosn͑召ꎋ. fBNgZp[^ \ / ꎋ.
 *	ȊO͒Pɕr.
 */
int   fname_cmp(const TCHAR* l, const TCHAR* r)
{
	return fname_n_cmp(l, r, (unsigned)-1);
}


/** t@C̑召r.
 *	win/dosn͑召ꎋ. fBNgZp[^ \ / ꎋ.
 *	ȊO͒Pɕr.
 */
int   fname_n_cmp(const TCHAR* l, const TCHAR* r, unsigned len)
{
 #if defined _WIN32 || defined MSDOS
	const TCHAR* e = l + len;
	assert( l != 0 && r != 0 );
	if (e < l)
		e = (const TCHAR*)-1;
	while (l < e) {
		int		 n;
		unsigned lc;
		unsigned rc;

		FNAME_GET_C(lc, l);
		FNAME_GET_C(rc, r);

		n  = (int)(lc - rc);
		if (n == 0) {
			if (lc == 0)
				return 0;
			continue;
		}

		if ((lc == _T('/') && rc == _T('\\')) || (lc == _T('\\') && rc == _T('/'))) {
			continue;
		}
		return n;
	}
	return 0;
 #else
	int i;
	assert( l != 0 && r != 0 );
  #if 1
	return FNAME_N_CMP(l, r, len);
  #else
	char* 	orig = setlocale(LC_CTYPE, s_fname_locale_ctype);
	i = FNAME_CMP(l, r);
	setlocale(orig);
	return i;
  #endif
 #endif
}



/** fnamebaseNameŎn܂Ă΁Afname̗]̐擪̃AhXԂ.
 *	}b`ĂȂNULLԂ.
 */
TCHAR*	 fname_equLong(FNAME_const TCHAR* fname, const TCHAR* baseName)
{
	unsigned l;
	assert(fname && baseName);
	l = FNAME_LEN(baseName);
	if (l == 0)
		return (TCHAR*)fname;
	return (fname_n_cmp(fname, baseName, l) == 0) ? (TCHAR*)fname+l : 0;
}



/** ?,* ݂̂(dos/win)ChJ[hr.
 * *,? ̓Zp[^ɂ̓}b`Ȃ.
 * g ** ̓Zp[^ɂ}b`.
 * unDonut̃\[XRsy.
 *	 ̌http://www.hidecnet.ne.jp/~sinzan/tips/main.htm炵N.
 *	@param ptn	p^[(*?w\)
 *	@param tgt	^[Qbg.
 */
int fname_matchWildCard(const TCHAR* ptn, const TCHAR* tgt)
{
	unsigned 		tc;
	const TCHAR*	tgt2 = tgt;
	FNAME_GET_C(tc, tgt2);	// 1擾& tgt|C^XV.
	switch (*ptn) {
	case _T('\0'):
		return tc == _T('\0');

  #if defined _WIN32 || defined MSDOS
	case _T('\\'):
	case _T('/'):
		return (tc == _T('/') || tc == _T('\\')) && fname_matchWildCard(ptn+1, tgt2);
  #endif

	case _T('?'):
		return tc && !IS_DIRSEP(tc) && fname_matchWildCard( ptn+1, tgt2 );

	case _T('*'):
		if (ptn[1] == _T('*'))	// ** ȂZp[^ɂ}b`.
			return fname_matchWildCard(ptn+2, tgt) || (tc && fname_matchWildCard( ptn, tgt2 ));
		return fname_matchWildCard(ptn+1, tgt) || (tc && !IS_DIRSEP(tc) && fname_matchWildCard( ptn, tgt2 ));

	default:
		{
			unsigned pc;
			FNAME_GET_C(pc, ptn);	// 1擾& ptn|C^XV.
			return (pc == tc) && fname_matchWildCard(ptn, tgt2);
		}
	}
}



// ============================================================================

TCHAR*	fname_relativePath(TCHAR dst[], unsigned size, const TCHAR* path, const TCHAR* currentDir) {
  #if defined WIN32 || defined MSDOS
	return fname_relativePathBS(dst, size, path, currentDir);
  #else
	return fname_relativePathSL(dst, size, path, currentDir);
  #endif
}


/** tpX. fBNgZp[^\\ɂĕԂo[W.
 */
TCHAR*	fname_relativePathBS(TCHAR dst[], unsigned size, const TCHAR* path, const TCHAR* currentDir)
{
	fname_relativePathSL(dst, size, path, currentDir);
	fname_slashToBackslash(dst);
	return dst;
}


/** currentDiȓ΃pX.
 *	currentDir ͐΃pXł邱. łȂꍇ͕̋s.
 *	'\'΍ŁAZp[^'/'ɒuĂ.
 *	JgfBNgn܂ꍇA"./"͂Ȃ.
 */
TCHAR*	fname_relativePathSL(TCHAR dst[], unsigned size, const TCHAR* path, const TCHAR* currentDir)
{
	enum { CHECK_MAX_PATH = sizeof(char[FNAME_MAX_PATH >= 16 ? 1 : -1]) };	// RpC̃TCY`FbN.
	enum { CHECK_MAX_URL  = sizeof(char[FNAME_MAX_URL  >= 16 ? 1 : -1]) };	// RpC̃TCY`FbN.
	TCHAR		curDir	[ FNAME_MAX_URL ];
	TCHAR		fullName[ FNAME_MAX_URL ];
	TCHAR		drvName [ FNAME_MAX_PATH ];
	TCHAR		drvName2[ FNAME_MAX_PATH ];
	TCHAR*		cp;
	TCHAR*		cpSav;
	TCHAR*		fp;

	assert(dst != 0 && size > 2 && path != 0);
	if (dst == 0 || size <= 2 || path == 0)
		return 0;

	// ܂AJgfBNgtpX(/) & Ō/t.
	assert(fname_isAbs(currentDir));
	fname_fullpathSL(curDir, FNAME_MAX_URL, currentDir, _T("/"));
	cp = fname_checkLastSep(curDir);
	if (cp == 0) {
		cp = curDir + FNAME_LEN(curDir);
		if (cp+1 < curDir+FNAME_MAX_URL) {
			*cp++ = _T('/');
			*cp = 0;
		}
	}

	// Ώۂ path tpX. \\͖ʓ|Ȃ̂/.
	fname_fullpathSL(fullName, FNAME_MAX_URL, path, curDir);

	// hCuĂ瑊΃pXȂ.
	fname_getDrive(drvName , FNAME_MAX_PATH, currentDir);
	fname_getDrive(drvName2, FNAME_MAX_PATH, fullName);
	if (fname_cmp(drvName, drvName2) != 0) {
		fname_cpy(dst, size, fullName);
		return dst;
	}

	// }b`ĂfBNgXLbv.
	cp	  = fname_skipDriveRoot(curDir);
	fp	  = fname_skipDriveRoot(fullName);
	cpSav = cp;
	while (*cp && *fp) {
		unsigned cc;
		unsigned fc;
		FNAME_GET_C(cc, cp);
		FNAME_GET_C(fc, fp);
		if (cc != fc)
			break;
		if (*cp == _T('/')) {
			cpSav = (TCHAR*)cp + 1;
		}
	}
	fp 		= fp - (cp - cpSav);
	cp 		= cpSav;

	// Jgʒuւ̈ړ../𐶐.
	{
		TCHAR*	d = dst;
		TCHAR*	e = dst + size - 1;
		while (*cp) {
			if (*cp == _T('/')) {
				if (d < e) *d++ = _T('.');
				if (d < e) *d++ = _T('.');
				if (d < e) *d++ = _T('/');
			}
			++cp;
		}
		*d = _T('\0');
	}

	// Jgʒuȉ̕Rs[
	fname_cat(dst, size, fp);

	return dst;
}



// ============================================================================
