/**
 *	@file	fname_cstring.h
 *	@brief	CStringNXt@CƂĈ߂̃Cu.
 *	@author	tenk*
 *	@note
 *	-	fname.h ̃bp[.
 *	-	TCHAR(UNICODE}N) ˑ.
 *	-	ϊrɃ[Ng߁At@C FNAME_MAX_URL Ɉˑ.
 *		  (winł _PAX_PATH=260ȏ̃TCY)
 *	- 	std::string(std::wstring) p fname_string.h قړl.
 *	-	Public Domain Software
 */

#ifndef FNAME_CSTRING_H
#define FNAME_CSTRING_H

#ifdef _WIN32
#include <windows.h>
#include <tchar.h>
#if 0
#include <atlbase.h>
#include <atlapp.h>
#include <atlmisc.h>
#endif
#endif

#include "fname.h"


#ifndef FNAME_STRING_BUF_SIZE
#define FNAME_STRING_BUF_SIZE	FNAME_MAX_URL
#endif


inline int	 fname_isAbs(const CString& path)	   { return fname_isAbs(LPCTSTR(path)); }
inline int	 fname_haveDrive(const CString& path) { return fname_haveDrive(LPCTSTR(path)); }

inline unsigned	 fname_adjust_size(const CString& str, unsigned size) {return fname_adjust_size(LPCTSTR(str), size); }

inline CString	fname_join(const CString& dir,const TCHAR *nm) {	///< fBNgƃt@C̘A.
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_join(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(dir), nm) );
}
inline CString	fname_join(const TCHAR* dir,const CString& nm) {	///< fBNgƃt@C̘A.
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_join(buf, FNAME_STRING_BUF_SIZE, dir, LPCTSTR(nm)) );
}
inline CString	fname_join(const CString& dir,const CString& nm) {	///< fBNgƃt@C̘A.
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_join(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(dir), LPCTSTR(nm)) );
}

inline CString fname_baseName(const CString& s)	{ return CString( fname_baseName( LPCTSTR(s) ) ); }
inline CString fname_ext(const CString& name) 	{ return CString( fname_ext( LPCTSTR(name) ) ); }
inline CString fname_skipDrive(const CString& name){return CString( fname_skipDrive( LPCTSTR(name) ) ); }
inline CString fname_skipDriveRoot(const CString& name){return CString( fname_skipDriveRoot( LPCTSTR(name) ) ); }

inline CString	fname_getNoExt(const CString& name) {		///< gqOO擾.
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_getNoExt(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(name) ) );
}

inline void fname_delExt(CString& name) {		///< gqOO擾.
  #if 1
	unsigned l = name.GetLength();
	TCHAR*	b = name.GetBuffer(l);
	fname_delExt(b);
	name.ReleaseBuffer();
  #else
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	fname_cpy(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(name));
	CString( fname_delExt(buf, FNAME_STRING_BUF_SIZE) );
  #endif
}

inline CString	fname_getNameNoExt(const CString& s) { CString t(s); fname_delExt(t); return t;}
inline CString	fname_getBaseNameNoExt(const CString& s) { return fname_getNameNoExt(fname_baseName(s)); }

inline CString	fname_setExt(const CString& src, const TCHAR *ext) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_setExt(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(src), ext) );
}
inline CString	fname_setExt(const TCHAR* src, const CString& ext) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_setExt(buf, FNAME_STRING_BUF_SIZE, src, LPCTSTR(ext)) );
}
inline CString	fname_setExt(const CString& src, const CString& ext) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_setExt(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(src), LPCTSTR(ext)) );
}

inline CString	fname_setDefaultExt(const CString& src, const TCHAR *ext) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_setDefaultExt(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(src), ext) );
}
inline CString	fname_setDefaultExt(const TCHAR* src, const CString& ext) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_setDefaultExt(buf, FNAME_STRING_BUF_SIZE, src, LPCTSTR(ext)) );
}
inline CString	fname_setDefaultExt(const CString& src, const CString& ext) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_setDefaultExt(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(src), LPCTSTR(ext)) );
}


inline CString	fname_getDir(const CString& nm) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_getDir(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(nm)) );
}


inline CString	fname_getDrive(const CString& nm) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_getDrive(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(nm)) );
}


inline CString	fname_getDriveRoot(const CString& nm) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_getDriveRoot(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(nm)) );
}


inline const TCHAR* fname_checkLastSep(const CString& nm) {
	const TCHAR* p = LPCTSTR(nm);
	return fname_checkLastSep( p );
}

inline CString	fname_addSep(const CString& nm) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	fname_cpy(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(nm));
	return CString( fname_addSep(buf, FNAME_STRING_BUF_SIZE) );
}

inline CString	fname_delLastSep(const CString& nm) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	fname_cpy(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(nm));
	return CString( fname_delLastSep(buf) );
}

inline CString fname_toUpper(const CString& filename) {
	CString	t(filename);
	fname_toUpper((TCHAR*)LPCTSTR(t));
	return t;
}

inline CString fname_toLower(const CString& filename) {
	CString	t(filename);
	fname_toLower((TCHAR*)LPCTSTR(t));
	return t;
}

inline CString fname_backslashToSlash(const CString& filename) {
	CString	t(filename);
	fname_backslashToSlash((TCHAR*)LPCTSTR(t));
	return t;
}

inline CString fname_slashToBackslash(const CString& filename) {
	CString	t(filename);
	fname_slashToBackslash((TCHAR*)LPCTSTR(t));
	return t;
}

// tpX
inline CString	fname_fullpath(const CString& path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_fullpath(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), LPCTSTR(currentDir) ) );
}

inline CString	fname_fullpath(const CString& path, const TCHAR* currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_fullpath(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), currentDir) );
}

inline CString	fname_fullpath(const TCHAR* path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_fullpath(buf, FNAME_STRING_BUF_SIZE, path, LPCTSTR(currentDir) ) );
}

inline CString	fname_fullpathSL(const CString& path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_fullpathSL(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), LPCTSTR(currentDir) ) );
}

inline CString	fname_fullpathSL(const CString& path, const TCHAR* currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_fullpathSL(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), currentDir) );
}

inline CString	fname_fullpathSL(const TCHAR* path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_fullpathSL(buf, FNAME_STRING_BUF_SIZE, path, LPCTSTR(currentDir) ) );
}


// ΃pX
inline CString	fname_relativePath(const CString& path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_relativePath(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), LPCTSTR(currentDir) ) );
}

inline CString	fname_relativePath(const CString& path, const TCHAR* currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_relativePath(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), currentDir) );
}

inline CString	fname_relativePath(const TCHAR* path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_relativePath(buf, FNAME_STRING_BUF_SIZE, path, LPCTSTR(currentDir) ) );
}

inline CString	fname_relativePathSL(const CString& path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_relativePathSL(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), LPCTSTR(currentDir) ) );
}

inline CString	fname_relativePathSL(const CString& path, const TCHAR* currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_relativePathSL(buf, FNAME_STRING_BUF_SIZE, LPCTSTR(path), currentDir) );
}

inline CString	fname_relativePathSL(const TCHAR* path, const CString& currentDir) {
	TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return CString( fname_relativePathSL(buf, FNAME_STRING_BUF_SIZE, path, LPCTSTR(currentDir) ) );
}



/// t@C̑召r.
inline int	 fname_cmp(const CString& l, const CString& r) { return fname_cmp(LPCTSTR(l), LPCTSTR(r)); }
inline int	 fname_cmp(const CString& l, const TCHAR*	r) { return fname_cmp(LPCTSTR(l), r			); }
inline int	 fname_cmp(const TCHAR*   l, const CString& r) { return fname_cmp(l			 , LPCTSTR(r)); }

inline int	 fname_n_cmp(const CString& l, const CString& r, unsigned n) { return fname_n_cmp(LPCTSTR(l), LPCTSTR(r),n); }
inline int	 fname_n_cmp(const CString& l, const TCHAR*   r, unsigned n) { return fname_n_cmp(LPCTSTR(l), r			,n); }
inline int	 fname_n_cmp(const TCHAR*	l, const CString& r, unsigned n) { return fname_n_cmp(l			 , LPCTSTR(r),n); }

inline size_t fname_equLong(const CString& fname, const CString& baseName) {
	const TCHAR*	s = LPCTSTR(fname);
	const TCHAR*	t = fname_equLong(s, LPCTSTR(baseName));
	return (t) ? (t - s) : 0;
}
inline size_t fname_equLong(const CString& fname, const TCHAR* baseName) {
	const TCHAR*	s = LPCTSTR(fname);
	const TCHAR*	t = fname_equLong(s, baseName);
	return (t) ? (t - s) : 0;
}
inline size_t fname_equLong(const TCHAR* fname, const CString& baseName) {
	const TCHAR*	t = fname_equLong(fname, LPCTSTR(baseName));
	return (t) ? (t - fname) : 0;
}


inline int fname_matchWildCard(const CString& pattern, const CString& str) {
	return fname_matchWildCard(LPCTSTR(pattern), LPCTSTR(str));
}
inline int fname_matchWildCard(const CString& pattern, const TCHAR* str) {
	return fname_matchWildCard(LPCTSTR(pattern), str);
}
inline int fname_matchWildCard(const TCHAR* pattern, const CString& str) {
	return fname_matchWildCard(pattern, LPCTSTR(str));
}


template<class STR_VEC>
void fname_scanArgStr(STR_VEC& vec, const TCHAR* str, unsigned exSepChr=_T(' ')) {
	typedef typename STR_VEC::value_type	String;
	const TCHAR* s = str;
	while (s && *s) {
		TCHAR	buf[ FNAME_STRING_BUF_SIZE ];
		s = fname_scanArgStr(buf, FNAME_STRING_BUF_SIZE, s, exSepChr);
		vec.push_vack(String(buf));
	}
}


#endif
