/**
 *	@file	fname_string.h
 *	@brief	stringNXt@CƂĈ߂̃Cu.
 *	@author	tenk*
 *	@note
 *	- 	fname.h ̃bp[.
 *	- 	winłTCHAR(UNICODE}N)ˑ. { std::string ܂ wtl::string p.
 *	- 	ϊrɃ[Ng߁At@C FNAME_MAX_URL Ɉˑ.
 *	  	(winł _PAX_PATH=260ȏ̃TCY)
 *	- 	fname_string.hincludeO FNAME_STRING }N`ŕstringNX
 *	  	ɒu\.
 *	- 	CString p fname_cstring.h قړl.
 *	-	Public Domain Software
 */

#ifndef FNAME_STRING_H
#define FNAME_STRING_H

#include "fname.h"

#if (defined FNAME_STRING)
 #ifndef FNAME_CSTR
  #define FNAME_CSTR(s)		s.c_str()			///< NXc̃|C^擾.
 #endif
#else
 #include <string>
 #if defined UNICODE
  #define FNAME_STRING		std::wstring		///< t@C߂镶NX.
  #define FNAME_CSTR(s)		s.c_str()			///< NXc̃|C^擾.
 #else
  #define FNAME_STRING		std::string			///< t@C߂镶NX.
  #define FNAME_CSTR(s)		s.c_str()			///< NXc̃|C^擾.
 #endif
#endif

#ifndef FNAME_STRING_BUF_SIZE
#define FNAME_STRING_BUF_SIZE	FNAME_MAX_URL
#endif



inline int	 fname_isAbs(const FNAME_STRING& path)	   { return fname_isAbs(FNAME_CSTR(path)); }
inline int	 fname_haveDrive(const FNAME_STRING& path) { return fname_haveDrive(FNAME_CSTR(path)); }

inline unsigned		fname_adjust_size(const FNAME_STRING& str, unsigned size) {return fname_adjust_size(FNAME_CSTR(str), size); }

inline FNAME_STRING  fname_join(const FNAME_STRING& dir,const FNAME_CHAR *nm) {	///< fBNgƃt@C̘A.
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_join(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(dir), nm) );
}
inline FNAME_STRING  fname_join(const FNAME_CHAR* dir,const FNAME_STRING& nm) {	///< fBNgƃt@C̘A.
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_join(buf, FNAME_STRING_BUF_SIZE, dir, FNAME_CSTR(nm)) );
}
inline FNAME_STRING  fname_join(const FNAME_STRING& dir,const FNAME_STRING& nm) {	///< fBNgƃt@C̘A.
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_join(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(dir), FNAME_CSTR(nm)) );
}

inline FNAME_STRING fname_baseName(const FNAME_STRING& s)	{ return FNAME_STRING( fname_baseName( FNAME_CSTR(s) ) ); }
inline FNAME_STRING fname_ext(const FNAME_STRING& name) 	{ return FNAME_STRING( fname_ext( FNAME_CSTR(name) ) ); }
inline FNAME_STRING fname_skipDrive(const FNAME_STRING& name){return FNAME_STRING( fname_skipDrive( FNAME_CSTR(name) ) ); }
inline FNAME_STRING fname_skipDriveRoot(const FNAME_STRING& name){return FNAME_STRING( fname_skipDriveRoot( FNAME_CSTR(name) ) ); }

inline FNAME_STRING  fname_getNoExt(const FNAME_STRING& name) {		///< gqOO擾.
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_getNoExt(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(name) ) );
}

inline void fname_delExt(FNAME_STRING& name) {		///< gqOO擾.
	size_t		l = name.size()+1;
	FNAME_CHAR*	p = (FNAME_CHAR*)FNAME_CSTR(name);
	fname_delExt( p );
	l = FNAME_LEN(p);
	name.resize(l);
}

inline FNAME_STRING  fname_getNameNoExt(const FNAME_STRING& s) { FNAME_STRING t(s); fname_delExt(t); return t;}
inline FNAME_STRING  fname_getBaseNameNoExt(const FNAME_STRING& s) { return fname_getNameNoExt(fname_baseName(s)); }

inline FNAME_STRING  fname_setExt(const FNAME_STRING& src, const FNAME_CHAR *ext) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_setExt(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(src), ext) );
}
inline FNAME_STRING  fname_setExt(const FNAME_CHAR* src, const FNAME_STRING& ext) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_setExt(buf, FNAME_STRING_BUF_SIZE, src, FNAME_CSTR(ext)) );
}
inline FNAME_STRING  fname_setExt(const FNAME_STRING& src, const FNAME_STRING& ext) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_setExt(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(src), FNAME_CSTR(ext)) );
}

inline FNAME_STRING  fname_setDefaultExt(const FNAME_STRING& src, const FNAME_CHAR *ext) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_setDefaultExt(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(src), ext) );
}
inline FNAME_STRING  fname_setDefaultExt(const FNAME_CHAR* src, const FNAME_STRING& ext) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_setDefaultExt(buf, FNAME_STRING_BUF_SIZE, src, FNAME_CSTR(ext)) );
}
inline FNAME_STRING  fname_setDefaultExt(const FNAME_STRING& src, const FNAME_STRING& ext) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_setDefaultExt(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(src), FNAME_CSTR(ext)) );
}


inline FNAME_STRING  fname_getDir(const FNAME_STRING& nm) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_getDir(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(nm)) );
}


inline FNAME_STRING  fname_getDrive(const FNAME_STRING& nm) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_getDrive(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(nm)) );
}


inline FNAME_STRING  fname_getDriveRoot(const FNAME_STRING& nm) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_getDriveRoot(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(nm)) );
}


inline const FNAME_CHAR* fname_checkLastSep(const FNAME_STRING& nm) {
	const FNAME_CHAR* p = FNAME_CSTR(nm);
	return fname_checkLastSep( p );
}

inline FNAME_STRING  fname_addSep(const FNAME_STRING& nm) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	fname_cpy(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(nm));
	return FNAME_STRING( fname_addSep(buf, FNAME_STRING_BUF_SIZE) );
}

inline FNAME_STRING  fname_delLastSep(const FNAME_STRING& nm) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	fname_cpy(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(nm));
	return FNAME_STRING( fname_delLastSep(buf) );
}

inline FNAME_STRING fname_toUpper(const FNAME_STRING& filename) {
	FNAME_STRING	t(filename);
	fname_toUpper((FNAME_CHAR*)FNAME_CSTR(t));
	return t;
}

inline FNAME_STRING fname_toLower(const FNAME_STRING& filename) {
	FNAME_STRING	t(filename);
	fname_toLower((FNAME_CHAR*)FNAME_CSTR(t));
	return t;
}

inline FNAME_STRING fname_backslashToSlash(const FNAME_STRING& filename) {
	FNAME_STRING	t(filename);
	fname_backslashToSlash((FNAME_CHAR*)FNAME_CSTR(t));
	return t;
}

inline FNAME_STRING fname_slashToBackslash(const FNAME_STRING& filename) {
	FNAME_STRING	t(filename);
	fname_slashToBackslash((FNAME_CHAR*)FNAME_CSTR(t));
	return t;
}

// tpX
inline FNAME_STRING  fname_fullpath(const FNAME_STRING& path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_fullpath(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), FNAME_CSTR(currentDir) ) );
}

inline FNAME_STRING  fname_fullpath(const FNAME_STRING& path, const FNAME_CHAR* currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_fullpath(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), currentDir) );
}

inline FNAME_STRING  fname_fullpath(const FNAME_CHAR* path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_fullpath(buf, FNAME_STRING_BUF_SIZE, path, FNAME_CSTR(currentDir) ) );
}

inline FNAME_STRING  fname_fullpathSL(const FNAME_STRING& path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_fullpathSL(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), FNAME_CSTR(currentDir) ) );
}

inline FNAME_STRING  fname_fullpathSL(const FNAME_STRING& path, const FNAME_CHAR* currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_fullpathSL(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), currentDir) );
}

inline FNAME_STRING  fname_fullpathSL(const FNAME_CHAR* path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_fullpathSL(buf, FNAME_STRING_BUF_SIZE, path, FNAME_CSTR(currentDir) ) );
}


// ΃pX
inline FNAME_STRING  fname_relativePath(const FNAME_STRING& path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_relativePath(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), FNAME_CSTR(currentDir) ) );
}

inline FNAME_STRING  fname_relativePath(const FNAME_STRING& path, const FNAME_CHAR* currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_relativePath(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), currentDir) );
}

inline FNAME_STRING  fname_relativePath(const FNAME_CHAR* path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_relativePath(buf, FNAME_STRING_BUF_SIZE, path, FNAME_CSTR(currentDir) ) );
}

inline FNAME_STRING  fname_relativePathSL(const FNAME_STRING& path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_relativePathSL(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), FNAME_CSTR(currentDir) ) );
}

inline FNAME_STRING  fname_relativePathSL(const FNAME_STRING& path, const FNAME_CHAR* currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_relativePathSL(buf, FNAME_STRING_BUF_SIZE, FNAME_CSTR(path), currentDir) );
}

inline FNAME_STRING  fname_relativePathSL(const FNAME_CHAR* path, const FNAME_STRING& currentDir) {
	FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
	return FNAME_STRING( fname_relativePathSL(buf, FNAME_STRING_BUF_SIZE, path, FNAME_CSTR(currentDir) ) );
}



/// t@C̑召r.
inline int	 fname_cmp(const FNAME_STRING& l, const FNAME_STRING& r) { return fname_cmp(FNAME_CSTR(l), FNAME_CSTR(r)); }
inline int	 fname_cmp(const FNAME_STRING& l, const FNAME_CHAR*   r) { return fname_cmp(FNAME_CSTR(l), r			); }
inline int	 fname_cmp(const FNAME_CHAR*   l, const FNAME_STRING& r) { return fname_cmp(l			 , FNAME_CSTR(r)); }

inline int	 fname_n_cmp(const FNAME_STRING& l, const FNAME_STRING& r, unsigned n) { return fname_n_cmp(FNAME_CSTR(l), FNAME_CSTR(r),n); }
inline int	 fname_n_cmp(const FNAME_STRING& l, const FNAME_CHAR*	r, unsigned n) { return fname_n_cmp(FNAME_CSTR(l), r			,n); }
inline int	 fname_n_cmp(const FNAME_CHAR*	 l, const FNAME_STRING& r, unsigned n) { return fname_n_cmp(l			 , FNAME_CSTR(r),n); }

inline size_t fname_equLong(const FNAME_STRING& fname, const FNAME_STRING& baseName) {
	const FNAME_CHAR*	s = FNAME_CSTR(fname);
	const FNAME_CHAR*	t = fname_equLong(s, FNAME_CSTR(baseName));
	return (t) ? (t - s) : 0;
}
inline size_t fname_equLong(const FNAME_STRING& fname, const FNAME_CHAR* baseName) {
	const FNAME_CHAR*	s = FNAME_CSTR(fname);
	const FNAME_CHAR*	t = fname_equLong(s, baseName);
	return (t) ? (t - s) : 0;
}
inline size_t fname_equLong(const FNAME_CHAR* fname, const FNAME_STRING& baseName) {
	const FNAME_CHAR*	t = fname_equLong(fname, FNAME_CSTR(baseName));
	return (t) ? (t - fname) : 0;
}


inline int fname_matchWildCard(const FNAME_STRING& pattern, const FNAME_STRING& str) {
	return fname_matchWildCard(FNAME_CSTR(pattern), FNAME_CSTR(str));
}
inline int fname_matchWildCard(const FNAME_STRING& pattern, const FNAME_CHAR* str) {
	return fname_matchWildCard(FNAME_CSTR(pattern), str);
}
inline int fname_matchWildCard(const FNAME_CHAR* pattern, const FNAME_STRING& str) {
	return fname_matchWildCard(pattern, FNAME_CSTR(str));
}

template<class STR_VEC>
void fname_scanArgStr(STR_VEC& vec, const FNAME_CHAR* str, unsigned exSepChr=_T(' ')) {
	typedef typename STR_VEC::value_type	String;
	const FNAME_CHAR* s = str;
	while (s && *s) {
		FNAME_CHAR	buf[ FNAME_STRING_BUF_SIZE ];
		s = fname_scanArgStr(buf, FNAME_STRING_BUF_SIZE, s, exSepChr);
		if (buf[0])
			vec.push_back(String(buf));
	}
}

#endif
